from BabbarPy.host import h_backlinks_url_list
from BabbarPy.url import u_fi
from urllib.parse import urlparse
import csv

def extract_host(url):
    parsed_url = urlparse(url)
    return parsed_url.hostname

def filter_max_fi_per_host(host_list):
    best_fi_per_host = {}
    for item in host_list:
        host = item['host']
        fi = item['fi']
        if host not in best_fi_per_host or fi > best_fi_per_host[host]['fi']:
            best_fi_per_host[host] = item
    return list(best_fi_per_host.values())

def main():
    host = input("Enter the host: ")
    api_key = input("Enter the api key: ")
    backlinks = h_backlinks_url_list(host, api_key)
    source_target_list = [{'source': item['source'], 'target': item['target']}
                          for item in backlinks if 'source' in item and 'target' in item]
    linklist_fi = []
    for i in source_target_list:
        data = u_fi(i['source'], i['target'], api_key).iloc[0].to_dict()
        host_from_source = extract_host(i['source'])
        data_fi = int(data['fi'])
        linklist_fi.append({'host': host_from_source, 'source': data['source'], 'target': data['target'], 'fi': data_fi})
    filtered_max_fi_host_list = filter_max_fi_per_host(linklist_fi)
    with open('filtered_max_fi_host_list.csv', 'w', newline='', encoding='utf-8') as csvfile:
        fieldnames = ['host', 'source', 'target', 'fi']
        writer = csv.DictWriter(csvfile, fieldnames=fieldnames)
        writer.writeheader()
        for row in filtered_max_fi_host_list:
            writer.writerow(row)

if __name__ == '__main__':
    main()















if __name__ == '__main__':
    main()